part of viltage;

class CharNode {
  int x, y;
  String char = "x";
  String color;
  String backgroundColor;
  List<String> classes = new List<String>();
  Map<String, String> attributes = new Map<String, String>();
  SpanElement se = new SpanElement();
    
  StringBuffer _sbClasses, _sbStyles;
  
  CharNode(this.x, this.y, this.char) { 
    classes.add("char_node");
    _sbClasses = new StringBuffer();
    _sbStyles = new StringBuffer();
  }
  
  SpanElement getSpanElement() {
    se.attributes = attributes;
    se.classes = classes;
    
    if(backgroundColor != null) se.attributes["background-color"] = backgroundColor;
    if(color != null) se.attributes["color"] = color;
    
    se.text = this.char;
    if(this.char == " ") se.text = "&nbsp;";
    
    return se;
  }
}